package se.nekotronic.bouncer;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintWriter;

public class ClientTalkerThread extends Thread {
	// private final MainServerThread owner;
	private final BufferedReader from_client;
	final PrintWriter to_client;
	private static int instances = 0;
	private int number = ++instances;
	private final SimpleLogger logger = new SimpleLogger("ClientTalkerThread " + number);
	private boolean quit = false;

	public ClientTalkerThread(BufferedReader from_client, PrintWriter to_client) {
		// this.owner = owner;
		this.from_client = from_client;
		this.to_client = to_client;
	}

	public void run() {
		while (! quit) {
			String line_from_client;
			try {
				line_from_client = from_client.readLine();
				if (line_from_client == null) {
					logger.log("Kunde inte lsa frn klienten");
					quit = true;
				}
				else if (line_from_client.equals("PING")) {
					logger.log("Fick ett PING frn klienten");
					send("PONG");
				}
				else if (line_from_client.equals("BYE")) {
					logger.log("Fick ett BYE frn klienten");
					send("BYE");
					quit = true;
				}
				else {
					logger.log("Fick felaktig rad frn klienten: '" + line_from_client + "'");
					send("ERROR");
				}
			}
			catch (IOException e) {
				logger.log("Tappat kontakten med klienten.");
				e.printStackTrace();
				quit = true;
			}
		} // while
		logger.log("Kopplar ner och avslutar trden");
		disconnect();
	} // run

	public void disconnect() {
		quit = true;
		try {
			from_client.close();
			to_client.close();
		} catch (IOException e) {
			// Failed. Not much we can do.
			logger.log("Problem vid nedkopplingen");
		}
	} // disconnect();
	
	public void send(String line) {
		to_client.println(line);
	}
} // class ClientListenerThread
